IDigitalWorldClientCreateOpts
Defined in: src/client.ts:469
Extends
Section titled “Extends”Properties
Section titled “Properties”accessToken?
Section titled “accessToken?”
optionalaccessToken?:string
Defined in: src/client.ts:320
Inherited from
Section titled “Inherited from”baseUrl
Section titled “baseUrl”baseUrl:
string
Defined in: src/client.ts:272
Inherited from
Section titled “Inherited from”cryptoCallbacks?
Section titled “cryptoCallbacks?”
optionalcryptoCallbacks?:CryptoCallbacks
Defined in: src/client.ts:425
Crypto callbacks provided by the application
Inherited from
Section titled “Inherited from”ICreateClientOpts.cryptoCallbacks
cryptoStore?
Section titled “cryptoStore?”
optionalcryptoStore?:CryptoStore
Defined in: src/client.ts:295
A store to be used for end-to-end crypto session data.
The createClient helper will create a default store if needed. Calls the factory supplied to
setCryptoStoreFactory if unspecified; or if no factory has been
specified, uses a default implementation (indexeddb in the browser,
in-memory otherwise).
This is only used for the legacy crypto implementation, but if you use the rust crypto implementation (DigitalWorldClient#initRustCrypto) and the device previously used legacy crypto (so must be migrated), then this must still be provided, so that the data can be migrated from the legacy store.
Inherited from
Section titled “Inherited from”deviceId?
Section titled “deviceId?”
optionaldeviceId?:string
Defined in: src/client.ts:318
A unique identifier for this device; used for tracking things like crypto keys and access tokens. If not specified, end-to-end encryption will be disabled.
Inherited from
Section titled “Inherited from”disableVoip?
Section titled “disableVoip?”
optionaldisableVoip?:boolean
Defined in: src/client.ts:449
Disable VoIP support (prevents fetching TURN servers, etc.) Default: false (VoIP enabled)
Inherited from
Section titled “Inherited from”enableEncryptedStateEvents?
Section titled “enableEncryptedStateEvents?”
optionalenableEncryptedStateEvents?:boolean
Defined in: src/client.ts:430
Enable encrypted state events.
Inherited from
Section titled “Inherited from”ICreateClientOpts.enableEncryptedStateEvents
fallbackICEServerAllowed?
Section titled “fallbackICEServerAllowed?”
optionalfallbackICEServerAllowed?:boolean
Defined in: src/client.ts:412
Whether to allow a fallback ICE server should be used for negotiating a WebRTC connection if the hub doesn’t provide any servers. Defaults to false.
Inherited from
Section titled “Inherited from”ICreateClientOpts.fallbackICEServerAllowed
fetchFn?
Section titled “fetchFn?”
optionalfetchFn?: {(input,init?):Promise<Response>; (input,init?):Promise<Response>; }
Defined in: src/client.ts:309
The function to invoke for HTTP requests.
Most supported environments have a global fetch registered to which this will fall back.
Call Signature
Section titled “Call Signature”(
input,init?):Promise<Response>
Parameters
Section titled “Parameters”URL | RequestInfo
RequestInit
Returns
Section titled “Returns”Promise<Response>
Call Signature
Section titled “Call Signature”(
input,init?):Promise<Response>
Parameters
Section titled “Parameters”string | URL | Request
RequestInit
Returns
Section titled “Returns”Promise<Response>
Inherited from
Section titled “Inherited from”forceTURN?
Section titled “forceTURN?”
optionalforceTURN?:boolean
Defined in: src/client.ts:394
Whether relaying calls through a TURN server should be forced. Default false.
Inherited from
Section titled “Inherited from”iceCandidatePoolSize?
Section titled “iceCandidatePoolSize?”
optionaliceCandidatePoolSize?:number
Defined in: src/client.ts:401
Up to this many ICE candidates will be gathered when an incoming call arrives. Gathering does not send data to the caller, but will communicate with the configured TURN server. Default 0.
Inherited from
Section titled “Inherited from”ICreateClientOpts.iceCandidatePoolSize
idBaseUrl?
Section titled “idBaseUrl?”
optionalidBaseUrl?:string
Defined in: src/client.ts:274
Inherited from
Section titled “Inherited from”identityServer?
Section titled “identityServer?”
optionalidentityServer?:IIdentityServerProvider
Defined in: src/client.ts:336
Identity server provider to retrieve the user’s access token when accessing the identity server. See also https://github.com/vector-im/element-web/issues/10615 which seeks to replace the previous approach of manual access tokens params with this callback throughout the SDK.
Inherited from
Section titled “Inherited from”ICreateClientOpts.identityServer
isVoipWithNoMediaAllowed?
Section titled “isVoipWithNoMediaAllowed?”
optionalisVoipWithNoMediaAllowed?:boolean
Defined in: src/client.ts:443
If true, participant can join group call without video and audio this has to be allowed. By default, a local media stream is needed to establish a group call. Default: false.
Inherited from
Section titled “Inherited from”ICreateClientOpts.isVoipWithNoMediaAllowed
livekitServiceURL?
Section titled “livekitServiceURL?”
optionallivekitServiceURL?:string
Defined in: src/client.ts:420
Inherited from
Section titled “Inherited from”ICreateClientOpts.livekitServiceURL
localTimeoutMs?
Section titled “localTimeoutMs?”
optionallocalTimeoutMs?:number
Defined in: src/client.ts:342
The default maximum amount of time to wait before timing out HTTP requests. If not specified, there is no timeout.
Inherited from
Section titled “Inherited from”ICreateClientOpts.localTimeoutMs
logger?
Section titled “logger?”
optionallogger?:Logger
Defined in: src/client.ts:461
A logger to associate with this DigitalWorldClient. Defaults to the built-in global logger; see DebugLogger for an alternative.
Inherited from
Section titled “Inherited from”pickleKey?
Section titled “pickleKey?”
optionalpickleKey?:string
Defined in: src/client.ts:380
Encryption key used for encrypting sensitive data (such as e2ee keys) in ICreateClientOpts#cryptoStore.
This must be set to the same value every time the client is initialised for the same device.
This is only used for the legacy crypto implementation, but if you use the rust crypto implementation (DigitalWorldClient#initRustCrypto) and the device previously used legacy crypto (so must be migrated), then this must still be provided, so that the data can be migrated from the legacy store.
Inherited from
Section titled “Inherited from”queryParams?
Section titled “queryParams?”
optionalqueryParams?:QueryDict
Defined in: src/client.ts:368
Extra query parameters to append
to all requests with this client. Useful for application services which require
?user_id=.
Inherited from
Section titled “Inherited from”refreshToken?
Section titled “refreshToken?”
optionalrefreshToken?:string
Defined in: src/client.ts:321
Inherited from
Section titled “Inherited from”ICreateClientOpts.refreshToken
roomNameGenerator?
Section titled “roomNameGenerator?”
optionalroomNameGenerator?: (roomId,state) =>string|null
Defined in: src/client.ts:436
Method to generate room names for empty rooms and rooms names based on membership. Defaults to a built-in English handler with basic pluralisation.
Parameters
Section titled “Parameters”roomId
Section titled “roomId”string
Returns
Section titled “Returns”string | null
Inherited from
Section titled “Inherited from”ICreateClientOpts.roomNameGenerator
scheduler?
Section titled “scheduler?”
optionalscheduler?:DigitalWorldScheduler<ISendEventResponse>
Defined in: src/client.ts:303
The scheduler to use. If not specified, this client will not retry requests on failure. This client will supply its own processing function to DigitalWorldScheduler#setProcessFunction.
Inherited from
Section titled “Inherited from”store?
Section titled “store?”
optionalstore?:IStore
Defined in: src/client.ts:281
The data store used for sync data from the hub. If not specified,
this client will not store any HTTP responses. The createClient helper
will create a default store if needed.
Inherited from
Section titled “Inherited from”supportsCallTransfer?
Section titled “supportsCallTransfer?”
optionalsupportsCallTransfer?:boolean
Defined in: src/client.ts:406
True to advertise support for call transfers to other parties on calls. Default false.
Inherited from
Section titled “Inherited from”ICreateClientOpts.supportsCallTransfer
timelineSupport?
Section titled “timelineSupport?”
optionaltimelineSupport?:boolean
Defined in: src/client.ts:361
Set to true to enable improved timeline support, see DigitalWorldClient#getEventTimeline. It is disabled by default for compatibility with older clients - in particular to maintain support for back-paginating the live timeline after a ‘/sync’ result with a gap.
Inherited from
Section titled “Inherited from”ICreateClientOpts.timelineSupport
tokenRefreshFunction?
Section titled “tokenRefreshFunction?”
optionaltokenRefreshFunction?:TokenRefreshFunction
Defined in: src/client.ts:328
Function used to attempt refreshing access and refresh tokens Called by http-api when a possibly expired token is encountered and a refreshToken is found
Inherited from
Section titled “Inherited from”ICreateClientOpts.tokenRefreshFunction
unstableMSC1763Retention?
Section titled “unstableMSC1763Retention?”
optionalunstableMSC1763Retention?:boolean
Defined in: src/client.ts:466
Locally remove events past the server global or per room retention setting.
Inherited from
Section titled “Inherited from”ICreateClientOpts.unstableMSC1763Retention
useAuthorizationHeader?
Section titled “useAuthorizationHeader?”
optionaluseAuthorizationHeader?:boolean
Defined in: src/client.ts:352
Set to false to send the access token to the server via a query parameter rather than the Authorization HTTP header.
Inherited from
Section titled “Inherited from”ICreateClientOpts.useAuthorizationHeader
useE2eForGroupCall?
Section titled “useE2eForGroupCall?”
optionaluseE2eForGroupCall?:boolean
Defined in: src/client.ts:418
If true, to-device signalling for group calls will be encrypted with Olm. Default: true.
Inherited from
Section titled “Inherited from”ICreateClientOpts.useE2eForGroupCall
useLivekitForGroupCalls?
Section titled “useLivekitForGroupCalls?”
optionaluseLivekitForGroupCalls?:boolean
Defined in: src/client.ts:455
If true, group calls will not establish media connectivity and only create the signaling events, so that livekit media can be used in the application layer (js-sdk contains no livekit code).
Inherited from
Section titled “Inherited from”ICreateClientOpts.useLivekitForGroupCalls
userId?
Section titled “userId?”
optionaluserId?:string
Defined in: src/client.ts:311
Inherited from
Section titled “Inherited from”usingExternalCrypto?
Section titled “usingExternalCrypto?”
optionalusingExternalCrypto?:boolean
Defined in: src/client.ts:475
Whether to allow sending messages to encrypted rooms when encryption is not available internally within this SDK. This is useful if you are using an external E2E proxy, for example. Defaults to false.
verificationMethods?
Section titled “verificationMethods?”
optionalverificationMethods?:string[]
Defined in: src/client.ts:389
Verification methods we should offer to the other side when performing an interactive verification. If unset, we will offer all known methods. Currently these are: showing a QR code, scanning a QR code, and SAS (aka “emojis”).
See types.VerificationMethod for a set of useful constants for this parameter.